#pragma once
#include "afxwin.h"


// CSettingsDialog dialog

class CSettingsDialog : public CDialog
{
	DECLARE_DYNAMIC(CSettingsDialog)

public:
  CSettingsDialog(CWnd* pParent = NULL);
	virtual ~CSettingsDialog();
  double getQuadsize();
  void setQuadsize(double quadSize);
  bool getInterpolate();
  void setInterpolate(bool interpolate);
  bool getAlign();
  void setAlign(bool alignQuadToGrid);
  bool getRemoveIntermediateFiles();
  void setRemoveIntermediateFiles(bool removeIntermediateFiles);
  int getLineThickness();
  void setLineThickness(int lineThickness);
  double getZScale();
  void setZScale(double zScale);
  int getHTTPTimeout();
  void setHTTPTimeout(int nHTTPTimeout);
  BOOL getUseWaypoints();
  void setUseWaypoints(BOOL u);
  CString getWaypointFile();
  void setWaypointFile(const CString &waypointFilename);
  BOOL getOutputFileNamesFromCoordinates();
  void setOutputFileNamesFromCoordinates(BOOL o);

// Dialog Data
	enum { IDD = IDD_SETTINGS_DIALOG };

protected:
  double quadSize;
  int lineThickness;
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
  CComboBox comboQuadsize;
  afx_msg void OnBnClickedOk();
  BOOL interpolate;
  BOOL alignQuadToGrid;
  BOOL removeIntermediateFiles;
  double zScale;
  int nHTTPTimeout;
  bool readWaypoints(const CString &pathName);

// Generated message map functions
	virtual BOOL OnInitDialog();
	DECLARE_MESSAGE_MAP()
public:
  afx_msg void OnBnClickedUsewaypoints();
  BOOL bUseWaypoints;
  CString strWaypointFile;
  CButton buttonBrowseWaypointFile;
  CEdit editWaypointFile;
  afx_msg void OnBnClickedBrowsewaypointfile();
  CComboBox comboLineThickness;
  afx_msg void OnCbnSelchangeComboQuadsize();
  BOOL outputFileNamesFromCoordinates;
};
