// WriteDemoTga.cpp: implementation file

#include "stdafx.h"

#include <afxtempl.h>
#include <float.h>

#include <list>
#include "Waypoint.h"

#include "geoDataClient.h"
#include "geoDataClientDialog.h"

// Writes "Unregistered TruFlite Demo" to a TGA file.
int CgeoDataClientDialog::WriteDemoTga(TGAFile &tgaFile)
{
  int DEMO_HEIGHT = tgaFile.GetImageHeight() / 24;
  CDC MemoryDC;
  MemoryDC.CreateCompatibleDC(NULL);
  CBitmap MaskBitmap;
  MaskBitmap.CreateBitmap(tgaFile.GetImageWidth(), DEMO_HEIGHT, 1, 1, NULL);
  CRect Rect(0, 0, tgaFile.GetImageWidth(), DEMO_HEIGHT);
  MemoryDC.SetTextColor(RGB(0, 0, 0));
  MemoryDC.SetBkColor(RGB(255, 255, 255));
  MemoryDC.SetBkMode(OPAQUE);
//  MemoryDC.SelectObject(&MaskBitmap); // New Adamiker 5/20/97
  CBitmap* pOldBitmap = MemoryDC.SelectObject(&MaskBitmap);
  CFont MaskFont;
  MaskFont.CreateFont(DEMO_HEIGHT,                 // nHeight
                      0,                           // nWidth
                      0,                           // nEscapement
                      0,                           // nOrientation
                      400,                         // nWeight
                      FALSE,                       // bItalic
                      FALSE,                       // bUnderline
                      FALSE,                       // bStrikeout
                      ANSI_CHARSET,                // nCharSet
                      OUT_TT_PRECIS,               // nOutPrecision
                      CLIP_TT_ALWAYS,              // nClipPrecision
                      PROOF_QUALITY,               // nQuality
                      TMPF_TRUETYPE |
                      DEFAULT_PITCH |
                      FF_SWISS,                    // nPitchAndFamily
                      NULL);                       // lpszFacename
//  MemoryDC.SelectObject(&MaskFont); // New Adamiker 5/20/97
  CFont* pOldFont = MemoryDC.SelectObject(&MaskFont);
  CString StrMask("\x96\x8D\x71\x46\x24\x0A\xF0"
                  "\xD7\xA6\x91\x66\x47\x63\x37"
                  "\xF1\xD6\x85\x8F\x6A\x57\x26"
                  "\x43\xC7\xC6\xAE\x8C");         // Decrypts into "Unregistered TruFlite Demo"
  char* p = StrMask.GetBuffer(256);
  unsigned short int n = 36547;
  while(*p)
  {
    *p = (char)((*p) ^ (char)n);
    n *= (unsigned short int)7777;
    p++;
  }
  StrMask.ReleaseBuffer();
  int nResult;
  nResult = MemoryDC.DrawText(StrMask, -1, &Rect, DT_CALCRECT | DT_SINGLELINE | DT_LEFT | DT_TOP);
  nResult = MemoryDC.DrawText(StrMask, -1, &Rect, DT_SINGLELINE | DT_LEFT | DT_TOP);
  RGBQUAD Color;
  memset(&Color, 0, sizeof(Color));
  COLORREF C;
  int nX, nY;
  for(nY = 1; nY < Rect.Height(); nY++)
  {
    for(nX = 0; nX < Rect.Width(); nX++)
    {
      C = MemoryDC.GetPixel(nX, Rect.Height() - nY);
      if(!GetRValue(C))
      {
        const int nLighter = 40;

        tgaFile.GetColor(nX + (tgaFile.GetImageWidth() - Rect.Width()) / 2,
                         nY + (tgaFile.GetImageHeight() - Rect.Height())/ 2,
                         &Color);
        if(Color.rgbRed < 255 - nLighter)
        {
          Color.rgbRed += nLighter;
        }
        else
        {
          Color.rgbRed = 255;
        };
        if(Color.rgbGreen < 255 - nLighter)
        {
          Color.rgbGreen += nLighter;
        }
        else
        {
          Color.rgbGreen = 255;
        };
        if(Color.rgbBlue < 255 - nLighter)
        {
          Color.rgbBlue += nLighter;
        }
        else
        {
          Color.rgbBlue = 255;
        };
        tgaFile.SetColor(nX + (tgaFile.GetImageWidth() - Rect.Width()) / 2,
                         nY + (tgaFile.GetImageHeight() - Rect.Height())/ 2,
                         &Color);
      }
    }
  }
  MemoryDC.SelectObject(pOldFont); // New Adamiker 5/20/97
  nResult = MaskFont.DeleteObject();
  MemoryDC.SelectObject(pOldBitmap); // New Adamiker 5/20/97
  nResult = MaskBitmap.DeleteObject();
  nResult = MemoryDC.DeleteDC();
  return 0;
}
