// geoDataClient.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"

#include <list>
#include "Waypoint.h"

#include "geoDataClient.h"
#include "geoDataClientDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

/*
 * geoDataClient
 *
 * (c) 2007 Martin D. Adamiker, Austria. All rights reserved.
 * No part of this source code may be copied, published or
 * modified without written consent by the author.
 *
 * Martin D. Adamiker
 * Tanbruckgasse 23/50
 * A-1120 Vienna
 * AUSTRIA
 * Tel. & Fax 01-8109633
 * martin@adamiker.com
 *
 * Coding Conventions:
 * - Braces vertically aligned
 * - Insert spaces instead of tabs
 * - Tab size: 2 spaces.
 * - Return codes of functions indicate errors if non-zero.
 * - Return codes of functions indicate success if zero.
 * 
 * Diagnostic output:
 * - Starting a conversion, name the input file(s).
 * - Ending a conversion, name the output file.
 * - Error inside a conversion
 * - End of the program
 *
 */

// CgeoDataClientApp

BEGIN_MESSAGE_MAP(CgeoDataClientApp, CWinApp)
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()


// CgeoDataClientApp construction

CgeoDataClientApp::CgeoDataClientApp()
{
	EnableHtmlHelp();

	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CgeoDataClientApp object

CgeoDataClientApp theApp;


// CgeoDataClientApp initialization

BOOL CgeoDataClientApp::InitInstance()
{
	CWinApp::InitInstance();

	if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	CgeoDataClientDialog dlg;
	m_pMainWnd = &dlg;
	INT_PTR nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}
